apt doesn't want to replace portmap with rpcbind on upgrade

Bug #863741 reported by Steve Langasek on 2011-09-30
24
This bug affects 3 people
Affects Status Importance Assigned to Milestone
nfs-utils (Ubuntu)
Medium
Michael Vogt
Oneiric
Medium
Michael Vogt
Precise
Medium
Steve Langasek
rpcbind (Ubuntu)
Undecided
Unassigned
Oneiric
Undecided
Unassigned
Precise
Undecided
Unassigned

Bug Description

[Test Case]
It's recommended to run this test in a VM or chroot.
1. On Ubuntu 10.04 LTS, run 'sudo apt-get install nfs-common'
2. Check that lucid-proposed is not enabled in /etc/apt/sources.list, and disable it if it is.
3. Run 'sudo do-release-upgrade -d' to upgrade to Ubuntu 12.04 LTS.
4. Confirm that the portmap package is still installed, and that rpcbind has not been installed
5. Repeat step 1 on a fresh 10.04 LTS environment.
6. Enable lucid-proposed in /etc/apt/sources.list.
7. Repeat step 3.
8. Confirm that the portmap package has been removed, and that rpcbind has been installed.

On upgrade from natty to oneiric, the old nfs-common got left behind because apt didn't want to replace portmap with rpcbind.

$ sudo apt-get -oDebug::PkgProblemResolver=1 dist-upgrade
Reading package lists... Done
Building dependency tree
Reading state information... Done
Calculating upgrade... Starting
Starting 2
Investigating (0) rpcbind [ amd64 ] < none -> 0.2.0-6ubuntu3 > ( net )
Broken rpcbind:amd64 Conflicts on portmap [ amd64 ] < 6.0.0-2ubuntu5 > ( net )
  Considering portmap:amd64 1 as a solution to rpcbind:amd64 0
  Holding Back rpcbind:amd64 rather than change portmap:amd64
Investigating (0) nfs-common [ amd64 ] < 1:1.2.2-4ubuntu5 -> 1:1.2.4-1ubuntu2 > ( net )
Broken nfs-common:amd64 Depends on rpcbind [ amd64 ] < none -> 0.2.0-6ubuntu3 > ( net ) (>= 0.2.0-6ubuntu1)
  Considering rpcbind:amd64 0 as a solution to nfs-common:amd64 0
  Holding Back nfs-common:amd64 rather than change rpcbind:amd64
 Try to Re-Instate (1) nfs-common:amd64
Done
Done
The following packages have been kept back:
  nfs-common
0 upgraded, 0 newly installed, 0 to remove and 1 not upgraded.
$

I don't know why this is. Maybe it has to do with the old portmap being Priority: standard, and rpcbind being Priority: optional?

Steve Langasek (vorlon) on 2011-09-30
Changed in nfs-utils (Ubuntu):
assignee: nobody → Michael Vogt (mvo)
Changed in nfs-utils (Ubuntu Oneiric):
importance: Undecided → Medium
Steve Langasek (vorlon) wrote :

I bumped the priority of rpcbind in the archive to 'standard', and that let apt figure out the upgrade. Problem solved. :)

Changed in nfs-utils (Ubuntu Oneiric):
status: New → Fix Released
Dac Chartrand (conner-bw) wrote :

I have thiis problem with an upgrade from 10.04 LTS to 12.04 LTS.

How do you "bump the priority of rpcbind in the archive to 'standard?"

-=-=-

$ sudo apt-get -oDebug::PkgProblemResolver=1 dist-upgrade
Reading package lists... Done
Building dependency tree
Reading state information... Done
Calculating upgrade... Starting
Starting 2
Investigating (0) rpcbind [ amd64 ] < none -> 0.2.0-7ubuntu1 > ( net )
Broken rpcbind:amd64 Conflicts on portmap [ amd64 ] < 6.0.0-1ubuntu2.2 > ( net )
  Considering portmap:amd64 1 as a solution to rpcbind:amd64 1
  Holding Back rpcbind:amd64 rather than change portmap:amd64
Investigating (0) nfs-common [ amd64 ] < 1:1.2.0-4ubuntu4.2 -> 1:1.2.5-3ubuntu3 > ( net )
Broken nfs-common:amd64 Depends on rpcbind [ amd64 ] < none -> 0.2.0-7ubuntu1 > ( net ) (>= 0.2.0-6ubuntu1)
  Considering rpcbind:amd64 1 as a solution to nfs-common:amd64 1
  Holding Back nfs-common:amd64 rather than change rpcbind:amd64
Investigating (0) nfs-kernel-server [ amd64 ] < 1:1.2.0-4ubuntu4.2 -> 1:1.2.5-3ubuntu3 > ( net )
Broken nfs-kernel-server:amd64 Depends on nfs-common [ amd64 ] < 1:1.2.0-4ubuntu4.2 -> 1:1.2.5-3ubuntu3 > ( net ) (= 1:1.2.5-3ubuntu3)
  Considering nfs-common:amd64 1 as a solution to nfs-kernel-server:amd64 0
  Holding Back nfs-kernel-server:amd64 rather than change nfs-common:amd64
 Try to Re-Instate (1) nfs-common:amd64
 Try to Re-Instate (1) nfs-kernel-server:amd64
Done
Done
The following packages have been kept back:
  nfs-common nfs-kernel-server
0 upgraded, 0 newly installed, 0 to remove and 2 not upgraded.

Steve Langasek (vorlon) wrote :

Ugh, that's quite bad. apparently the archive priority was set correctly in oneiric, but somehow came undone again in precise... probably because there were no packages depending on rpcbind at priority: standard so this showed up as an archive inconsistency.

I'm not sure what the right way is to fix this for precise. We could do a no-change SRU or pocket-copy to precise-updates, and change the priority there. That might be sufficient.

Changed in nfs-utils (Ubuntu Precise):
status: New → Triaged
importance: Undecided → Medium
assignee: nobody → Steve Langasek (vorlon)

I am having the same problem and unfortunately I do not find these solutions clear for me :(

Is there anything I can do to fix this myself? How do I change the priority of rpcbind in the archive? Should I wait for the software providers to complete an update?

On Wed, May 30, 2012 at 01:54:15PM -0000, Johnathon Walls wrote:

> Is there anything I can do to fix this myself?

You can run 'sudo apt-get install rpcbind' manually.

> How do I change the priority of rpcbind in the archive?

You don't. This is something the Ubuntu developers have to do.

Steve Langasek (vorlon) on 2012-05-30
Changed in nfs-utils (Ubuntu Precise):
status: Triaged → In Progress

Wonderful, thanks. Installing rpcbind manually worked perfectly.

Hello Steve, or anyone else affected,

Accepted rpcbind into precise-proposed. The package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

tags: added: verification-needed
Changed in nfs-utils (Ubuntu Precise):
status: In Progress → Fix Committed
Steve Langasek (vorlon) on 2012-05-31
Changed in rpcbind (Ubuntu):
status: New → Invalid
Changed in rpcbind (Ubuntu Oneiric):
status: New → Fix Released
Changed in rpcbind (Ubuntu Precise):
status: New → Fix Committed
Changed in nfs-utils (Ubuntu Precise):
status: Fix Committed → Invalid
Dac Chartrand (conner-bw) wrote :
Download full text (3.2 KiB)

Seems to work for me. I rebooted. I can mount my Windows partition. I can browse the internal Windows network. Nothing seems broken.

Some backstory: I discovered this bug when trying to solve my own "askubuntu.com" problem, see:

http://askubuntu.com/questions/128933/cannot-update-nfs-the-update-manager-shows-packages-but-wont-let-me-select-the

In the above URL, I am using the "Update Manager" GUI.

When trying to help solve this bug (eg. a reply to comment #7 by cjwatson) I did 6 steps:

1) I went into the graphical "Ubutnu Software Centre" 2) I put a checkmark next to "precise-proposed" in the Sources tab; Edit -> Software Sources. 3) In "Update Manager" i clicked "Check." At this point I was asked to upgrade something like 90+ packages. I freaked out a bit and exited the GUI. Instead, I went to the terminal and I did 4)

-=-=-

$ sudo apt-get install rpcbind nfs-common
Reading package lists... Done
Building dependency tree
Reading state information... Done
The following packages will be REMOVED:
  portmap
The following NEW packages will be installed:
  rpcbind
The following packages will be upgraded:
  nfs-common
1 upgraded, 1 newly installed, 1 to remove and 91 not upgraded.
Need to get 279 kB of archives.
After this operation, 41.0 kB of additional disk space will be used.
Do you want to continue [Y/n]? y
Get:1 http://us.archive.ubuntu.com/ubuntu/ precise/main nfs-common amd64 1:1.2.5-3ubuntu3 [236 kB]
Get:2 http://us.archive.ubuntu.com/ubuntu/ precise-proposed/main rpcbind amd64 0.2.0-7ubuntu1.1 [42.6 kB]
Fetched 279 kB in 0s (474 kB/s)
(Reading database ... 199442 files and directories currently installed.)
Preparing to replace nfs-common 1:1.2.0-4ubuntu4.2 (using .../nfs-common_1%3a1.2.5-3ubuntu3_amd64.deb) ...
Unpacking replacement nfs-common ...
Processing triggers for ureadahead ...
Processing triggers for man-db ...
(Reading database ... 199455 files and directories currently installed.)
Removing portmap ...
portmap stop/waiting
Processing triggers for ureadahead ...
Processing triggers for man-db ...
Selecting previously unselected package rpcbind.
(Reading database ... 199442 files and directories currently installed.)
Unpacking rpcbind (from .../rpcbind_0.2.0-7ubuntu1.1_amd64.deb) ...
Processing triggers for man-db ...
Processing triggers for ureadahead ...
Setting up rpcbind (0.2.0-7ubuntu1.1) ...
Installing new version of config file /etc/init/portmap.conf ...
Installing new version of config file /etc/init/portmap-wait.conf ...
 Removing any system startup links for /etc/init.d/rpcbind ...
portmap start/running, process 13937
Setting up nfs-common (1:1.2.5-3ubuntu3) ...
Installing new version of config file /etc/init/gssd.conf ...
Installing new version of config file /etc/init/idmapd.conf ...
Replacing config file /etc/idmapd.conf with new version
Replacing config file /etc/default/nfs-common with new version
statd stop/waiting
statd start/running, process 14226
gssd stop/pre-start, process 14255
idmapd start/running, process 14296

-=-=-

5) At this point I went back to Software Sources GUI and unchecked "precise-proposed" 6) In the Update Manager GUI I clicked "Check" again and this time I was asked to upg...

Read more...

Steve Langasek (vorlon) wrote :

I've verified this fix using the test case that I've just added to the bug description, so I think this can be considered done.

description: updated
tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package rpcbind - 0.2.0-7ubuntu1.1

---------------
rpcbind (0.2.0-7ubuntu1.1) precise-proposed; urgency=low

  * No-change rebuild of rpcbind so we can publish with a different version
    number to precise-updates, allowing apt to see that this package is
    Priority: standard so it will be installed in favor of portmap on
    upgrade. LP: #863741.
 -- Steve Langasek <email address hidden> Wed, 30 May 2012 09:19:16 -0700

Changed in rpcbind (Ubuntu Precise):
status: Fix Committed → Fix Released

This bug is NOT fixed.

I just updated my up-to-date 10.04 system to 12.04.

I'm hitting this bug now.

Although Update Manager cannot deal with the problem, this seems to fix it:
 sudo apt-get install rpcbind

Steve Langasek (vorlon) wrote :

Hugh, the original bug has been fixed. If you're still seeing the same symptom, we would need to see apt debugging output from an affected system in order to diagnose this.

bogstad (bogstad) wrote :

I'm seeing the same thing on a system recently upgraded directly from 10.04 to 12.04. Here's the debugging output:

# apt-get -oDebug::PkgProblemResolver=1 dist-upgrade
Reading package lists... Done
Building dependency tree
Reading state information... Done
Calculating upgrade... Starting
Starting 2
Investigating (0) rpcbind [ i386 ] < none -> 0.2.0-7ubuntu1.2 > ( net )
Broken rpcbind:i386 Conflicts on portmap [ i386 ] < 6.0.0-1ubuntu2.2 > ( net )
  Considering portmap:i386 1 as a solution to rpcbind:i386 1
  Holding Back rpcbind:i386 rather than change portmap:i386
Investigating (0) nfs-common [ i386 ] < 1:1.2.0-4ubuntu4.2 -> 1:1.2.5-3ubuntu3.1 > ( net )
Broken nfs-common:i386 Depends on rpcbind [ i386 ] < none -> 0.2.0-7ubuntu1.2 > ( net ) (>= 0.2.0-6ubuntu1)
  Considering rpcbind:i386 1 as a solution to nfs-common:i386 1
  Holding Back nfs-common:i386 rather than change rpcbind:i386
Investigating (0) nfs-kernel-server [ i386 ] < 1:1.2.0-4ubuntu4.2 -> 1:1.2.5-3ubuntu3.1 > ( net )
Broken nfs-kernel-server:i386 Depends on nfs-common [ i386 ] < 1:1.2.0-4ubuntu4.2 -> 1:1.2.5-3ubuntu3.1 > ( net ) (= 1:1.2.5-3ubuntu3.1)
  Considering nfs-common:i386 1 as a solution to nfs-kernel-server:i386 0
  Holding Back nfs-kernel-server:i386 rather than change nfs-common:i386
 Try to Re-Instate (1) nfs-common:i386
 Try to Re-Instate (1) nfs-kernel-server:i386
Done
Done
The following packages have been kept back:
  nfs-common nfs-kernel-server
0 upgraded, 0 newly installed, 0 to remove and 2 not upgraded.

On Fri, May 24, 2013 at 04:05:59AM -0000, bogstad wrote:
> I'm seeing the same thing on a system recently upgraded directly from
> 10.04 to 12.04. Here's the debugging output:

Thanks. Can you also show the output from:

# apt-get -oDebug::PkgProblemResolver=1 install nfs-kernel-server

?

(It may be best to capture the output without applying the upgrade, in case
we need more debugging information later.)

Peter Matulis (petermatulis) wrote :

I just observed this after a Lucid:Precise upgrade. It was a fresh Lucid install and all that was done was a simple NFS server share export and then do-release-upgrade.

My workaround was purging nfs-common and nfs-kernel-server and then reinstalling them. Results:

The following extra packages will be installed:
  libtirpc1 rpcbind
The following packages will be REMOVED:
  portmap
The following NEW packages will be installed:
  libtirpc1 nfs-common nfs-kernel-server rpcbind

Peter Matulis (petermatulis) wrote :

I redid the test (install, upgrade) and simply asked to install nfs-kernel-server. It worked (?). See attachment.

Peter Matulis (petermatulis) wrote :

Here are the APT logs.

Peter Matulis (petermatulis) wrote :

Clarification. I logs I uploaded are:

/var/log/dist-upgrade/{apt.log,main.log}

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers